题目:连续子序列


解题思路:

首先,不能使用暴力枚举,时间为O(n2),超时。以下为正确做法:

假设找到一段区间(其和>=m),如上图黄色部分,那么该区间加上i后面的元素形成的新区间和都>=m,因此以该区间为基础就有n-i+1个区间符合要求。

那么我们只需要从1开始找到每一个恰好大于等于m的黄色区间,再依次把每一个黄色区间为基础的区间的个数相加就得到答案。


AC代码:

cpp 复制代码
#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int N = 1e5+9;
int a[N];
ll m;
// 依次找出区间和>=m的滑动窗口,j++ 
int main()
{
     ll sum = 0,ans = 0;
    int n, j = 1;cin >> n >> m;
    for(int i = 1; i <= n; i++){
        cin >> a[i];
        sum += a[i];
        if(sum >= m)
        {
            ans += (n-i+1);
            while(j <= i && sum >= m){  // 数组从1开始序号递增,所以当序号i>=j时区间合法 
            sum -= a[j];
            j++;
            if(sum >= m)ans += (n-i+1);
            } 
        }
    }
    cout << ans << '\n';    
    return 0;
}

知识点:

双指针,滑动窗口

相关推荐
凯瑟琳.奥古斯特8 分钟前
力扣1016高效解法:剪枝优化技巧
开发语言·c++·算法·leetcode·职场和发展
xiangyun6139 分钟前
C++ priority_queue 底层:手撕二叉堆与 Top K 问题
c++·算法·面试·stl·1024程序员节
qz_Serene1 小时前
练习算法题:双指针 -cpp
c++·算法·leetcode·1024程序员节
Nuanyt2 小时前
Hot 100 刷题笔记 · 数组与哈希专题(3 题)
java·笔记·算法·leetcode·哈希算法·1024程序员节
碧海银沙音频科技研究院2 小时前
基于炬芯平台ATS308X多模型兼容语音识别算法
人工智能·算法·语音识别
爱读书的小胖2 小时前
LeetCode 274 H 指数 C 语言解题分析
c语言·算法·leetcode·1024程序员节
basketball6163 小时前
动态规划第一章:引论
算法·动态规划·1024程序员节
星夜离尘563 小时前
MATLAB 因果采样保持:用历史匹配和数据年龄防止未来信息泄漏
数据结构·算法·matlab
思麟呀4 小时前
BTree的原理与 C++ 完整实现
c语言·数据结构·c++·算法·1024程序员节
Tsuki_tl4 小时前
【优选算法 — 双指针】经典例题题解+算法总结
算法·蓝桥杯·力扣·刷题·双指针·1024程序员节·优选算法